# encoding: UTF-8

def show_problem

  @lang_hash = {'lid1'=> %Q(élan 勢い Schwung импульс)}  # I'm using a hash because it's what I use in my plugin...

  @dlg2 = UI::WebDialog.new("Problem_Main", false,"main_prob", 700, 600, 600, 0, false)

  html = %Q(
  <!DOCTYPE html>
  <html>
  <head>
  <title>Problem_Main</title>
  <meta content="text/html; charset=utf-8" http-equiv="Content-Type">
  <style>
  body{font-family:sans-serif;}
  input{width:100%;}
  .my_text{width:99%;margin-bottom:10px;}
  </style>
  </head>
  <body>
    <p>Tested using Sketchup.version #{Sketchup.version}</p>
    <p>Tested on #{RUBY_PLATFORM =~ /(darwin)/ ? ((%x(sw_vers).sub(/ProductName:/,'').sub(/ProductVersion:/,'').sub(/BuildVersion:/,'_'))) : %x[ver]}</p>
    <p>Encoding::locale_charmap in use #{Sketchup.version.include?('14') ? Encoding::locale_charmap : 'Not Available'} for #{Sketchup.get_locale} locale.</p>
    <input class="my_text" id="#{@lang_hash.keys[0]}" name="" value="#{@lang_hash.values[0]}" "type="text"
    onkeyup="if (event.keyCode == 13) {trans_L8_raw(#{@lang_hash.keys[0]});}"  title="type text and then 'Enter'">
    <input type="button" value="Use Enter/Return in the Input Box to show raw...then...Click here to show fix. "
    onclick="{trans_L8_fix(#{@lang_hash.keys[0]});}"  title="Click when ready">
    <p>below is the return using 'get_element_value'</p>
    <h4 id="translation1">return appears here</h4>
    <p>below is the return using 'get_element_value' after fix</p>
    <h4 id="translation2">return appears here</h4>
    <p>below is the return using 'add_action_callback' </p>
    <h4 id="translation3">return appears here </h4>
    <p>below is the return using 'add_action_callback' after fix </p>
    <h4 id="translation4">return appears here</h4>
    <br>
    <input type="button" value="Click to save dlg as an image on your Desktop for submission to SCF..." onclick="{su_snap();}">

    <script type="text/javascript" charset="UTF-8">

      function trans_L8_raw(this_one) {
        window.location = 'skp:trans_L8_raw@'+this_one.id+','+this_one.value;
      }

      function trans_L8_fix(this_one) {
        this_one.name = this_one.value;
        this_one.value=unicodeLiteral(this_one.value);
        window.location = 'skp:trans_L8_fix@'+this_one.id+','+this_one.value;
      }

      function trans_L8(this_one) {
        trans_L8_raw(this_one);
        trans_L8_fix(this_one);
      }

      function su_snap() {
        window.location = 'skp:su_snap'
      }

      /* Creates a uppercase hex number with at least length digits from a given number */
      function fixedHex(number, length){
          var str = number.toString(16).toUpperCase();
          while(str.length < length)
              str = "0" + str;
          return str;
      }

      /* Creates a unicode literal based on the string. nts: UTF-8 is an encoding - Unicode is a character set*/
      function unicodeLiteral(str){
          var i;
          var result = "";
          for( i = 0; i < str.length; ++i){
              /* You should probably replace this by an isASCII test */
              if(str.charCodeAt(i) > 126 || str.charCodeAt(i) < 32)
                  result += "\\\\" + "u" + fixedHex(str.charCodeAt(i),4);
              else
                  result += str[i];
          }
    return result;
}

    </script>
  </body>
</html>
)

  @dlg2.set_html html

  RUBY_PLATFORM =~ /(darwin)/ ? @dlg2.show_modal() : @dlg2.show()

  @dlg2.add_action_callback("su_snap") {@dlg2.write_image(File.join((File.expand_path(ENV["HOME"])), "Desktop", "encoding_issue_#{Sketchup.version}.png"))}

  @dlg2.add_action_callback("trans_L8_raw") {|dialog, params|

    param_id = params.split(',')[0].to_s
    param_val = params.split(',')[1]
    callback = 'return using add_action_callback [id,value] '
    puts callback
    p(param_val)

    @dlg2.execute_script("translation1.innerText='#{param_val}'")

    elm_val = (@dlg2.get_element_value(param_id)).to_s
    element_value = 'return using get_element_value => ' + elm_val
    puts element_value

    @dlg2.execute_script("translation3.innerText='#{elm_val}'")
  }

  @dlg2.add_action_callback("trans_L8_fix") {|dialog, params|

    param_id = params.split(',')[0].to_s
    param_fix = params.split(',')[1].gsub('/',"\\").to_s
    callback = 'return using add_action_callback [id,value_fixed] '
    puts callback
    puts param_fix

    @dlg2.execute_script("translation2.innerText='#{param_fix}';")

    elm_fix = (@dlg2.get_element_value(param_id)).to_s
    element_value = 'return using get_element_value fixed => ' + elm_fix
    puts element_value

    @dlg2.execute_script("translation4.innerText='#{elm_fix}'")
    @dlg2.execute_script("#{param_id}.value=#{param_id}.name;")
  }

end
show_problem

# load("/Users/johns_iMac/Library/Application Support/SketchUp 2014/SketchUp/Plugins/jcb_ViewPortResize/dev/show_encoding_issue.rb")
# load("[add your path]/show_encoding_issue.rb")
